#! /bin/sh

DIE=0

rm -f config.cache

srcdir=`dirname $0`
test -z "$srcdir" && srcdir=.

(test -f $srcdir/configure.in) || {
    echo -n "*** Error ***: Directory "\`$srcdir\'" does not look like the"
    echo " top-level directory"
    exit 1
}

(autoconf --version) < /dev/null > /dev/null 2>&1 || {
        echo 
        echo "You must have autoconf installed to compile $PROG."
        echo "Download the appropriate package for your distribution,"
        echo "or get the source tarball at ftp://ftp.gnu.org/pub/gnu/"
        DIE=1
}

(automake --version) < /dev/null > /dev/null 2>&1 || {
        echo
        echo "You must have automake installed to compile $PROG."
        echo "Get ftp://ftp.gnu.org/pub/gnu/automake-1.3.tar.gz"
        echo "(or a newer version if it is available)"
        DIE=1
}
        
(aclocal --version) < /dev/null > /dev/null 2>&1 || {
        echo
        echo "**Error**: Missing aclocal. The version of automake"
        echo "installed doesn't appear recent enough."
        echo "Get ftp://ftp.gnu.org/pub/gnu/automake-1.3.tar.gz" 
        echo "(or a newer version if it is available)"
        DIE=1
}

if [ "$DIE" -eq 1 ]; then
        exit 1
fi

set -x
aclocal -I config
autoheader
automake --foreign --add-missing --copy
autoconf

rm -f config.cache
