/***************************************************************************
   bare.cpp  -  bare bones plugin
                             -------------------
    begin                : Wed Jul 03 2002
    copyright            : (C) 2002 by red0x
    email                : red0x@users.sourceforge.net
    rcsid                : $Id: bare.c,v 1.2 2002/08/08 04:06:00 red0x Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/** @file bare.c
  * Contains a bare bones plugin that does nothing
  * This file is a good example of the plugin API.
  * Use it as an example for your own plugin development.
  */

#include <assert.h>
#include "bare.h"

static const char rcsid[] =
        "\100$ autosec/sonar: $Id: bare.c,v 1.2 2002/08/08 04:06:00 red0x Exp $";

/** @name Plugin API -- Plugin side
  * Every plugin you make must have a plugin_init function
  * exported as a C function, so its name wont get mangled.
  * The duty of this function is to fill a plugin_t structure
  * with function pointers to your plugin's functions and do
  * any other setup, and then return the address of the plugin_t
  * structure.
  * That is the only Mandatorily named function in your plugin.
 */
//@{
/** @fn plugin_init(void *in_data)
  * Plugin Init function, part of the Plugin API
  * @param in_data Pointer to a sonar_t structure that will be 
  *  passed from sonar when your plugin is loaded.
  * @return A pointer to a filled plugin_t structure.
  */

void *plugin_init(void *in_data)
{
        {
                assert(in_data != NULL);
        }
        //useless reference, to avoid a warning
        if(rcsid)
        {
        }
        // this is assumed
        mthis = (sonar_t *) in_data;

        pthis.type = INPUT_PLUGIN | OUTPUT_PLUGIN;
        pthis.errno = &my_errno;
        pthis.ready = false;
        pthis.plugin_init = &plugin_init;
        pthis.plugin_destroy = &plugin_destroy;
        pthis.plugin_args = &plugin_args;
        pthis.plugin_open = &plugin_open;
        pthis.plugin_close = &plugin_close;
        pthis.plugin_next = &plugin_next;
        // this is not needed for I/O plugins
        pthis.plugin_sweep = NULL;
        // red0x: do we even need this??
        pthis.plugin_go = NULL;
        pthis.plugin_usage = &plugin_usage;
        pthis.plugin_status = &plugin_status;
        pthis.plugin_last_error = &plugin_last_error;
        my_errno = PLUGIN_LOADED;

        return &pthis;
}


static int plugin_destroy(void)
{

        mthis = NULL;

        pthis.type = 0;
        pthis.errno = NULL;
        pthis.ready = false;
        pthis.plugin_init = NULL;
        pthis.plugin_destroy = NULL;
        pthis.plugin_open = NULL;
        pthis.plugin_close = NULL;
        pthis.plugin_next = NULL;
        pthis.plugin_sweep = NULL;
        pthis.plugin_args = NULL;
        pthis.plugin_sweep = NULL;
        // red0x: do we even need this??
        pthis.plugin_go = NULL;
        pthis.plugin_usage = NULL;
        pthis.plugin_status = NULL;
        pthis.plugin_last_error = NULL;
        my_errno = PLUGIN_UNLOADED;
        return my_errno;
}

static int plugin_args(char opt, char *optarg)
{
        assert(mthis != NULL);
        assert(mthis->output != NULL);
        assert(mthis->memput != NULL);
        switch (opt)
        {
                default:
                        //we dont handle this
                        return PLUGIN_ERROR;
        }
        return PLUGIN_OK;
}

static int plugin_open(void *c_data, int i_data)
{
        return PLUGIN_ERROR;
}

static int plugin_close(void)
{
        return PLUGIN_OK;
}

static int plugin_next(char *hostname)
{
        return PLUGIN_ERROR;
}

static void plugin_usage(void)
{
        assert(mthis != NULL);
        assert(mthis->output != NULL);
        mthis->output("Bare plugin -- no use\n");
}

static void plugin_status(void)
{
        assert(mthis != NULL);
        assert(mthis->output != NULL);
        mthis->output("Bare plugin loaded::\n");
}

static int plugin_last_error(void)
{
        return my_errno;
}
//@}
