/***************************************************************************
   bare.h  -  bare bones plugin
                             -------------------
    begin                : Wed Jul 03 2002
    copyright            : (C) 2002 by red0x
    email                : red0x@users.sourceforge.net
    rcsid                : $Id: bare.h,v 1.2 2002/08/08 04:06:00 red0x Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/** @file bare.h
  * Contains a bare bones plugin that does nothing
  * This file is a good example of the plugin API.
  * Use it as an example for your own plugin development.
  */
#ifndef _BARE_H_
#define _BARE_H_

// include the plugin API
#include "plugin.h"
// include my types
#include "types.h"
#include <sys/types.h>
#include <unistd.h>
#include <sys/time.h>

/// Plugin's plugin_t structure, built by plugin_init
plugin_t pthis;
/// Sonar's sonar_t structure, built by sonar, passed to this plugin
sonar_t *mthis;

/// my last error
int my_errno;

// put your definitions here

// put your prototypes here
// make them static and make sure their linkage is "C"
void *plugin_init(void *in_data);
static int plugin_destroy(void);
static int plugin_args(char opt, char *optarg);
static int plugin_open(void *c_data, int i_data);
static int plugin_close(void);
static int plugin_next(char *hostname);
static void plugin_usage(void);
static void plugin_status(void);
static int plugin_last_error(void);
static void inline error(char *x, int y)
{
	mthis->message("%s:%d ERROR %s\n", __FILE__, __LINE__, x);
	*(pthis.errno) = y;
}

#endif //_BARE_H_
