/***************************************************************************
   passive.h  -  passive scanning plugin
                             -------------------
    begin                : Wed Jul 03 2002
    copyright            : (C) 2002 by red0x
    email                : red0x@users.sourceforge.net
    rcsid                : $Id: passive.h,v 1.4 2002/08/08 08:33:04 red0x Exp $
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/** @file passive.h
  * Contains passive scanner that listens for incoming packets
  */
#ifndef _PASSIVE_H_
#define _PASSIVE_H_

// include the plugin API
#include "plugin.h"
// include my types
#include "types.h"
#include <sys/types.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

/// Plugin's plugin_t structure, built by plugin_init
plugin_t pthis;
/// Sonar's sonar_t structure, built by sonar, passed to this plugin
sonar_t *mthis;

/// my last error
int my_errno;
static int my_delay, my_socket, myudp_socket, myicmp_socket;

// put your definitions here
#define BUFSIZE	4096

// put your prototypes here
// make them static and make sure their linkage is "C"
void *plugin_init(void *in_data);
static int plugin_destroy(void);
static int plugin_args(char opt, char *optarg);
static int plugin_open(void *c_data, int i_data);
static int plugin_sweep(void *data);
static int plugin_close(void);
static int plugin_next(char *hostname);
static void plugin_usage(void);
static void plugin_status(void);
static int plugin_last_error(void);
static void print_ip(struct ip *, struct sockaddr_in, char *);
static void print_udp(struct udphdr *, struct sockaddr_in);
static void print_tcp(struct tcphdr *, struct sockaddr_in);
static void print_icmp(struct icmp *, struct sockaddr_in);
static void inline error(char *x, int y)
{
	mthis->message("%s:%d ERROR %s\n", __FILE__, __LINE__, x);
	*(pthis.errno) = y;
}

#endif //_PASSIVE_H_
