/***************************************************************************
                          util.h  -  description
                             -------------------
    begin                : Wed Apr 17 2002
    copyright            : (C) 2002 by red0x
    email                : red0x@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UTIL_H_
#define UTIL_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "types.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#ifndef INADDR_NONE
#define INADDR_NONE  ((in_addr_t) 0xffffffff)
#endif

extern char *cline;
extern FILE *raw_output;
extern int main(int, char **);

void sonar_usage(const char *err);
void bput(char **dest, const char *src, const int len);
void sonar_commandline(char *argv[], int argc, char **out);
unsigned short checksum(unsigned short *buffer, int size);
void tvsub(register struct timeval *out, register struct timeval *in);
void sonar_msg(char *msg, ...);
RETSIGTYPE sig_term(int i);
RETSIGTYPE sig_int(int i);
RETSIGTYPE sig_kill(int i);
RETSIGTYPE sig_hup(int i);
RETSIGTYPE sig_segv(int i);
int sonar_setoutput(char *fname);
int sonar_isip(char *ip);
unsigned long sonar_resolve(char *host);

#endif
